#include <fxlib.h>
#include "menu.h"
#include "tileset.h"
#include "MonochromeLib.h"
#include "LibText.h"
#include "functions.h"

#define MODE(x,y) (x==y?TXT_REV:TXT_OR)

int lb[100];

int displayMenu(int opt1, int opt2, int opt3) {
	Tileset *menu = tileset_load(MENU_BD);
	Tileset *perso = tileset_load(PERSO);
	Tileset *wall = tileset_load(WALL);
	Tileset *achieved = tileset_load(ACHIEVED);
	const char deco[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		2,3,0,0,0,0,0,0,0,2,0,0,0,0,0,2,
		2,3,3,0,0,2,0,3,0,2,0,3,0,4,0,2,
		2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
	};
	const char txt1[] = "Your goal is to get to the door on the map. Your character can fall any height but can only climb up one unit. You can pick up blocks with nothing on top of them and set them down in front of you or on top of a one-unit obstacle in front of you.\nControls\rleft arrow : move left\rright arrow : move right\rdown arrow : pick up or drop block\rup arrow : move upwards\rR key : reset current level\rshift key : hold shift and use arrows to pan";
	const char txt2[] = "Block Dude created by Brandon Sterner and adapted by Purobaz\rwww.planet-casio.com\rthanks to PierrotLL and Lephenixnoir for their libraries";
	char c[40];
	int i, j, k;
	int down = 1;
	
	Txt_Init(FONT_ARCADIUM | FONT_MINISD | FONT_SERIFITALIC | FONT_RUNES);
	
	ML_clear_vram();
	ML_bmp_or(menu->tile[0], 33, 3, 61, 9);
	
	for(j = 0 ; j < 6 ; j++) {
		for(i = 0 ; i < 16 ; i++) {
			switch(deco[16*j+i]) {
				case 2 : 
					ML_bmp_8_or(wall->tile[0], 8*i, 8*j);
				break;
				case 3 :
					ML_rectangle(8*i, 8*j, 8*i+7, 8*j+7, 1, ML_BLACK, ML_WHITE);
				break;
				case 4 :
					ML_bmp_or(perso->tile[0], 8*i, 8*j, 6, 8);
			}
		}
	}
	
	switch(opt1) {
		case 3 :
			ML_rectangle(22, 14, 105, 50, 1, ML_BLACK, ML_WHITE);
			ML_rectangle(22, 14, 105, 22, 1, ML_BLACK, ML_BLACK);
			uintToChar(&c, opt2);
			if(opt2 >= 10) i = 1;
			else i = 0;
			Txt_Text("Level", 51, 16, TXT_ARCADIUM, TXT_AND);
			Txt_Text(&c, 61-3*i, 31, TXT_SERIFITALIC, TXT_OR);
			if(opt2 > 1) Txt_Text(")", 53-3*i, 30, TXT_RUNES, TXT_OR);
			if(opt2 < 11 && opt2 < opt3) Txt_Text("(", 68+4*i, 30, TXT_RUNES, TXT_OR);
		break;
		case 4 :
			ML_rectangle(12, 14, 115, 60, 1, ML_BLACK, ML_WHITE);
			ML_rectangle(12, 14, 115, 22, 1, ML_BLACK, ML_BLACK);
			Txt_Text("Help", 51, 16, TXT_ARCADIUM, TXT_AND);
			if(opt2 < 0) {
				calcText(&txt1, 94);
				opt2 = 0;
			}
			for(i = 0 ; i < 5 ; i++) {
				if(lb[2*i+1+opt2] != 0) {
					for(k = 0 ; k+lb[2*i+opt2] < lb[2*i+1+opt2] ; k++) c[k] = txt1[k+lb[2*i+opt2]];
					c[k] = '\0';
					Txt_Text(c, 15, 25+7*i, TXT_MINISD, TXT_OR);
				}
			}
			if(lb[opt2+10] == 0 && lb[opt2+14] == 0) down = 0;
		break;
		case 5 :
			ML_rectangle(12, 14, 115, 60, 1, ML_BLACK, ML_WHITE);
			ML_rectangle(12, 14, 115, 22, 1, ML_BLACK, ML_BLACK);
			Txt_Text("Credits", 44, 16, TXT_ARCADIUM, TXT_AND);
			if(opt2 < 0) {
				calcText(&txt2, 94);
				opt2 = 0;
			}
			for(i = 0 ; i < 5 ; i++) {
				if(lb[2*i+1+opt2] != 0) {
					for(k = 0 ; k+lb[2*i+opt2] < lb[2*i+1+opt2] ; k++) c[k] = txt2[k+lb[2*i+opt2]];
					c[k] = '\0';
					Txt_Text(c, 15, 25+7*i, TXT_MINISD, TXT_OR);
				}
			}
			if(lb[opt2+10] == 0 && lb[opt2+14] == 0) down = 0;
		break;
		default :
			Txt_Text("by Purobaz", 34, 14, TXT_ARCADIUM, TXT_OR);
			switch(opt1) {
				case 0 :
					ML_rectangle(8, 52, 31, 58, 1, ML_BLACK, ML_WHITE);
				break;
				case 1 :
					ML_rectangle(43, 52, 67, 58, 1, ML_BLACK, ML_WHITE);
				break;
				case 2 :
					ML_rectangle(77, 52, 118, 58, 1, ML_BLACK, ML_WHITE);
				break;
			}
			Txt_Text("Play", 9, 53, TXT_ARCADIUM, MODE(opt1, 0));
			Txt_Text("Help", 44, 53, TXT_ARCADIUM, MODE(opt1, 1));
			Txt_Text("Credits", 78, 53, TXT_ARCADIUM, MODE(opt1, 2));
			if(opt2 >= 10) {
				ML_bmp_and(achieved->tile[0], 65, 0, 46, 31);
				ML_bmp_or(achieved->tile[1], 65, 0, 46, 31);
			}
	}
	ML_display_vram();
	
	tileset_free(menu);
	tileset_free(perso);
	tileset_free(wall);
	tileset_free(achieved);
	Txt_Quit();
	
	return down;
}

void calcText(const char *txt, int l) {
	int i = 0, j = 1;
	lb[0] = 0;
	while(txt[i] != '\0') {
		switch(txt[i]) {
			case ' ' : 
				if((i-1-lb[j-1])*4 > l) {
					lb[j+1] = lb[j]+1;
					j += 2;
				}
				else lb[j] = i;
			break;
			case '\n' :
				if((i-1-lb[j-1])*4 > l) {
					lb[j+1] = lb[j]+1;
					lb[j+2] = i;
					lb[j+3] = 0;
					lb[j+4] = 0;
					lb[j+5] = i+1;
					j += 6;

				}
				else {
					lb[j] = i;
					lb[j+1] = 0;
					lb[j+2] = 0;
					lb[j+3] = i+1;
					j += 4;
				}
			break;
			case '\r' :
				if((i-1-lb[j-1])*4 > l) {
					lb[j+1] = lb[j]+1;
					lb[j+2] = i;
					lb[j+3] = i+1;
					j += 4;
				}
				else {
					lb[j] = i;
					lb[j+1] = i+1;
					j += 2;
				}
		}
		i++;
	}
	if((i-1-lb[j-1])*4 > l) {
		lb[j+1] = lb[j]+1;
		lb[j+2] = i;
		j += 3;
	}
	else {
		lb[j] = i;
		j++;
	}
	
	for(j ; j < 100 ; j++) lb[j] = 0;
}

void finalAnim(void) {
	Tileset *menu = tileset_load(MENU_BD);
	Tileset *perso = tileset_load(PERSO);
	Tileset *wall = tileset_load(WALL);
	Tileset *achieved = tileset_load(ACHIEVED);
	
	const char deco[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
		2,3,0,0,0,0,0,0,0,2,0,0,0,0,0,2,
		2,3,3,0,0,2,0,3,0,2,0,3,0,4,0,2,
		2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
	};
	int i, j;
	int anim;
	int sequin[100][4];
	
	Txt_Init(FONT_ARCADIUM);
	random(RTC_getTicks(), 0);
	
	for(i = 0 ; i < 100 ; i++) {
		sequin[i][0] = 88*1000;
		sequin[i][1] = 15*1000;
		sequin[i][2] = random(0,2200)-1100;
		sequin[i][3] = random(0,2200)-1100;
	}
	
	for(anim = 0 ; anim < 80 ; anim++) {
		ML_clear_vram();
		ML_bmp_or(menu->tile[0], 33, 3, 61, 9);
		
		for(j = 0 ; j < 6 ; j++) {
			for(i = 0 ; i < 16 ; i++) {
				switch(deco[16*j+i]) {
					case 2 : 
						ML_bmp_8_or(wall->tile[0], 8*i, 8*j);
					break;
					case 3 :
						ML_rectangle(8*i, 8*j, 8*i+7, 8*j+7, 1, ML_BLACK, ML_WHITE);
					break;
					case 4 :
						ML_bmp_or(perso->tile[0], 8*i, 8*j, 6, 8);
				}
			}
		}
		
		if(anim > 5) {
			for(i = 0 ; i < 100 ; i++) {
				if(sequin[i][0]/1000 >= 0 && sequin[i][0]/1000 < 128 && sequin[i][1]/1000 >= 0 && sequin[i][1]/1000 < 64) ML_pixel(sequin[i][0]/1000, sequin[i][1]/1000, ML_BLACK);
				sequin[i][0] += sequin[i][2];
				sequin[i][1] += sequin[i][3];
			}
			ML_bmp_and(achieved->tile[0], 65, 0, 46, 31);
			ML_bmp_or(achieved->tile[1], 65, 0, 46, 31);
		}
		
		ML_display_vram();
		Sleep(40);
	}
	
	tileset_free(menu);
	tileset_free(perso);
	tileset_free(wall);
	tileset_free(achieved);
	Txt_Quit();
}