#include <stdlib.h>
#include "tileset.h"

Tileset* tileset_load(Tileset_name name)
{
	Tileset* tileset = NULL;
	if(name == MENU_BD) {
		const char bmp[] = {
				0xfe, 0xc0, 0x0, 0x20, 0x7f, 0xc0, 0x1, 0x7, 0x32, 0x40, 0x0, 0x20, 0x20, 0x60, 0x1, 0x7, 0x24, 0x40, 0x0, 0x40, 0x20, 0x20, 0x1, 0x7, 0x48, 0x86, 0xe, 0x58, 0x40, 0x28, 0x87, 0x37, 0x7e, 0x99, 0x30, 0xa0, 0x40, 0x29, 0x19, 0x4f, 0x82, 0xa1, 0x40, 0xc0, 0x80, 0x51, 0x22, 0x4f, 0x82, 0xa2, 0x41, 0x40, 0x80, 0x92, 0x44, 0xb7, 0x85, 0x24, 0x45, 0x20, 0x81, 0x16, 0x4c, 0x87, 0xf9, 0x18, 0x39, 0x20, 0xfe, 0x9, 0x32, 0x77
			};
		tileset = tileset_create(bmp, 61, 9, 1);
	}
	if(name == PERSO) {
		const char bmp[] = {
				0x3b, 0xff, 0x27, 0x47, 0x2b, 0x57, 0x13, 0x6f,
				0x73, 0xff, 0x93, 0x8b, 0x53, 0xab, 0x23, 0xdb
			};
		tileset = tileset_create(bmp, 6, 8, 2);
	}
	if(name == WALL) {
		const char bmp[] = {
				0xfb, 0xfb, 0x0, 0xfe, 0xfe, 0x0, 0xfb, 0xfb
			};
		tileset = tileset_create(bmp, 8, 8, 1);
	}
	if(name == ACHIEVED) {
		const char bmp[] = {
				0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xcd, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xb6, 0x3f, 0xff, 0xff, 0xff, 0xff, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xc7, 0xff, 0xff, 0xff, 0xff, 0x36, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xd5, 0xff, 0xff, 0xff, 0xff, 0xf6, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xf7, 0x1f, 0xff, 0xff, 0xff, 0xfd, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x3b, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xdf, 0xff, 0xff, 0xff, 0xff, 0x8d, 0xdf, 0xff, 0xff, 0xff, 0xff, 0x7d, 0xff, 0xff, 0xff, 0xff, 0xe3, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
				0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0x0, 0x0, 0x0, 0x0, 0xf, 0xdf, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xdf, 0x0, 0x0, 0x0, 0x0, 0xff, 0xdf, 0x0, 0x0, 0x0, 0x3, 0xfe, 0x1f, 0x0, 0x0, 0x0, 0xf, 0xcd, 0xdf, 0x0, 0x0, 0x0, 0x3f, 0xb6, 0x3f, 0x0, 0x0, 0x0, 0xff, 0x8f, 0xff, 0x0, 0x0, 0x3, 0xfe, 0xbf, 0xf3, 0x0, 0x0, 0xf, 0xf6, 0xc7, 0xc3, 0x0, 0x0, 0x3f, 0x36, 0xff, 0x3, 0x0, 0x0, 0xfe, 0xd5, 0xfc, 0x3, 0x0, 0x3, 0xf6, 0x3b, 0xf0, 0x3, 0x0, 0xf, 0xfe, 0xff, 0xc0, 0x3, 0x0, 0x3d, 0xf7, 0x1f, 0x0, 0x3, 0x0, 0xfd, 0xf7, 0xfc, 0x0, 0x3, 0x3, 0xfd, 0x3b, 0xf0, 0x0, 0x3, 0xf, 0xfc, 0xdf, 0xc0, 0x0, 0x3, 0x3f, 0x8d, 0xdf, 0x0, 0x0, 0x3, 0xff, 0x7d, 0xfc, 0x0, 0x0, 0x3, 0xe3, 0x7f, 0xf0, 0x0, 0x0, 0x3, 0xfd, 0x8f, 0xc0, 0x0, 0x0, 0x3, 0xe1, 0xff, 0x0, 0x0, 0x0, 0x3, 0xdd, 0xfc, 0x0, 0x0, 0x0, 0x3, 0xe3, 0xf0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x3, 0xff, 0x0, 0x0, 0x0, 0x0, 0x3, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x3
			};
		tileset = tileset_create(bmp, 46, 31, 2);
	}
	
	return tileset;
}

void tileset_free(Tileset* tileset)
{
	int i;
	if(tileset) {
		for(i=0 ; i<tileset->length ; i++)
			free(tileset->tile[i]);
		free(tileset->tile);
		free(tileset);
	}
}

static Tileset* tileset_create(const char* bmp, int width, int height, int length)
{
	Tileset* tileset;
	int i, byte_width, tile_size;
	byte_width = (width-1)/8+1;
	tile_size = byte_width * height;
	
	tileset = malloc(sizeof(Tileset));
	if(!tileset) return NULL;

	tileset->width = width;
	tileset->height = height;
	tileset->length = length;
	tileset->tile = malloc(sizeof(char*) * length);
	if(!tileset->tile) {
		free(tileset);
		return NULL;
	}
	
	for(i=0 ; i<length ; i++) {
		tileset->tile[i] = malloc(tile_size);
		if(!tileset->tile[i]) {
			for( ; i ; i--)
				free(tileset->tile[i-1]);
			free(tileset->tile);
			free(tileset);
			return NULL;
		}
		memcpy(tileset->tile[i], bmp+i*tile_size, tile_size);
	}
	return tileset;
}